/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.system.vo;

import javax.servlet.http.HttpServletRequest;

import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.base.PayrollVo;
import jp.mosp.payroll.dto.DetailDto;

/**
 * 明細設定編集画面における情報を扱う。<br><br>
 */
public class DetailCardVo extends PayrollVo {
	
	private static final long serialVersionUID = 7009008251901023868L;
	
	// フィールド
	private String pltType  ;
	private String txtCode  ;
	private String txtName  ;
	private String txtAbbr  ;
	private String pltDelete;
	
	// プルダウン
	private String[][] pitType;
	
	// 画面モード
	private int mode;
	
	/**
	 * パラメータ名(コード)。
	 */
	public static final String PRM_PLT_TYPE = "pltType";
	
	/**
	 * パラメータ名(コード(非表示))。
	 */
	public static final String PRM_HID_TYPE = "hidType";
	
	/**
	 * パラメータ名(コード)。
	 */
	public static final String PRM_TXT_CODE = "txtCode";
	
	/**
	 * パラメータ名(名称)。
	 */
	public static final String PRM_TXT_NAME = "txtName";
	
	/**
	 * パラメータ名(略称)。
	 */
	public static final String PRM_TXT_ABBR = "txtAbbr";
	
	/**
	 * パラメータ名(削除フラグ)。
	 */
	public static final String PRM_PLT_DELETE = "pltDelete";
	
	/**
	 * パラメータ名(削除フラグ(非表示))。
	 */
	public static final String PRM_HID_DELETE = "hidDelete";
	
	/**
	 * 項目長(明細コード)
	 */
	public static final int LEN_CODE = PayrollConst.LEN_DETAIL_CODE;
	
	/**
	 * 項目長(明細名)
	 */
	public static final int LEN_NAME = PayrollConst.LEN_DETAIL_NAME;
	
	/**
	 * 項目長(明細略称)
	 */
	public static final int LEN_ABBR = PayrollConst.LEN_DETAIL_ABBR;
	
	/**
	 * 項目名称(コード)。
	 */
	public String NAM_TYPE;
	
	/**
	 * 項目名称(コード)。
	 */
	public String NAM_CODE;
	
	/**
	 * 項目名称(名称)。
	 */
	public String NAM_NAME;
	
	/**
	 * 項目名称(略称)。
	 */
	public String NAM_ABBR;
	
	/**
	 * 項目名称(削除フラグ)。
	 */
	public String NAM_DELETE;
	
	/**
	 * {@link PayrollVo#PayrollVo()}を実行する。
	 */
	public DetailCardVo() {
		super();
	}
	
	/**
	 * 項目名称を設定する。
	 */
	@Override
	protected void setFieldsName() {
		super.setFieldsName();
		pitType = getDetailTypeArray();
		NAM_TYPE   = getName("P_DETAIL") + getName("P_TYPE"      );
		NAM_CODE   = getName("P_DETAIL") + getName("C_CODE"      );
		NAM_NAME   = getName("P_DETAIL") + getName("C_NAME"      );
		NAM_ABBR   = getName("P_DETAIL") + getName("P_ABBREVIATE");
		NAM_DELETE = getName("P_DELETE_FLAG");
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.payroll.base.PayrollVo#setSubTitle()
	 */
	@Override
	protected void setSubTitle() {
		super.setSubTitle();
		subTitle = getName("P_DETAIL") + getName("P_SETTING");
		addAryMenu("P1002", getName("P_PAYMENT") +
				getName("P_CALCULATE") + getName("C_MASTER") + getName("C_TO"));
	}
	
	/**
	 * リクエストからパラメータを取得、設定する。
	 * @param request リクエスト
	 */
	public void setParams(HttpServletRequest request) {
		pltType   = request.getParameter(PRM_HID_TYPE  );
		txtCode   = request.getParameter(PRM_TXT_CODE  );
		txtName   = request.getParameter(PRM_TXT_NAME  );
		txtAbbr   = request.getParameter(PRM_TXT_ABBR  );
		pltDelete = request.getParameter(PRM_HID_DELETE);
	}
	
	/**
	 * フィールドを設定する。<br>
	 * @param dto 明細設定DTO
	 */
	public void setFields(DetailDto dto) {
		txtCode = dto.getDetailCode();
		txtName = dto.getDetailName();
		txtAbbr = dto.getDetailAbbr();
		pltDelete = String.valueOf(dto.getDeleteFlag());
	}
	
	/**
	 * JavaScript設定
	 * @param cls 情報取得クラス
	 * @param obj 情報取得オブジェクト
	 * @throws IllegalAccessException
	 */
	@Override
	public String getDirectJs(Class<?> cls, Object obj) throws IllegalAccessException {
		StringBuffer sb = new StringBuffer();
		sb.append(super.getDirectJs(cls, obj));
		sb.append("var MODE = " + mode + ";");
		return sb.toString();
	}
	
	/**
	 * 区分プルダウンアイテムを取得する。
	 * @return 区分プルダウンアイテム
	 */
	public String[][] getPitType() {
		return getAryField(pitType);
	}

	/**
	 * 区分プルダウンアイテムを設定する。
	 * @param pitType 設定する区分プルダウンアイテム
	 */
	public void setPitType(String[][] pitType) {
		this.pitType = getAryField(pitType);
	}

	/**
	 * 削除フラグを取得する。
	 * @return 削除フラグ
	 */
	public String getPltDelete() {
		return pltDelete;
	}

	/**
	 * 削除フラグを設定する。
	 * @param pltDelete 設定する削除フラグ
	 */
	public void setPltDelete(String pltDelete) {
		this.pltDelete = pltDelete;
	}

	/**
	 * 区分を取得する。
	 * @return 区分
	 */
	public String getPltType() {
		return pltType;
	}

	/**
	 * 区分を設定する。
	 * @param pltType 設定する区分
	 */
	public void setPltType(String pltType) {
		this.pltType = pltType;
	}
	
	/**
	 * 略称を取得する。
	 * @return 略称
	 */
	public String getTxtAbbr() {
		return txtAbbr;
	}

	/**
	 * 略称を設定する。
	 * @param txtAbbr 設定する略称
	 */
	public void setTxtAbbr(String txtAbbr) {
		this.txtAbbr = txtAbbr;
	}

	/**
	 * 略称を取得する。
	 * @return 略称
	 */
	public String getEscTxtAbbr() {
		return escapeHTML(txtAbbr);
	}

	/**
	 * コードを取得する。
	 * @return コード
	 */
	public String getTxtCode() {
		return txtCode;
	}

	/**
	 * コードを設定する。
	 * @param txtCode 設定するコード
	 */
	public void setTxtCode(String txtCode) {
		this.txtCode = txtCode;
	}

	/**
	 * コードを取得する。
	 * @return コード
	 */
	public String getEscTxtCode() {
		return escapeHTML(txtCode);
	}

	/**
	 * 名称を取得する。
	 * @return 名称
	 */
	public String getTxtName() {
		return txtName;
	}

	/**
	 * 名称を設定する。
	 * @param txtName 設定する名称
	 */
	public void setTxtName(String txtName) {
		this.txtName = txtName;
	}
	
	/**
	 * 名称を取得する。
	 * @return 名称
	 */
	public String getEscTxtName() {
		return escapeHTML(txtName);
	}
	
	/**
	 * 画面モードを設定する。<br><br>
	 * 0:新規、1：更新、2：更新(編集不可)
	 * @param mode 設定する画面モード
	 */
	public void setMode(int mode) {
		this.mode = mode;
	}
	
}
